<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Izg 2018 - 2019, lab 6.: quadExample</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Izg 2018 - 2019, lab 6.
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">quadExample</div>  </div>
</div><!--header-->
<div class="contents">
<p><a class="el" href="quadExample_8c.html" title="This file contains implementation of simple quad example. ">quadExample.c</a> </p><div class="image">
<img src="quad.png" alt="quad.png"/>
<div class="caption">
The figure shows the output of the quad example.</div></div>
<p> Tento příklad vykreslí jeden barevný čtverec s použitím indexování. </p>
<h1><a class="anchor" id="Globals"></a>
Globální proměnné</h1>
<p>Globální proměnné jsou uloženy ve struktuře: </p><div class="fragment"><div class="line"></div>
<div class="line"><span class="keyword">struct </span><a name="_a0"></a><a class="code" href="structQuadExampleVariables.html">QuadExampleVariables</a>{</div>
<div class="line">  GLuint <a name="a1"></a><a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a>                ;<span class="comment">//a program id</span></div>
<div class="line"><span class="comment"></span>  GLint  <a name="a2"></a><a class="code" href="structQuadExampleVariables.html#a38a1023cb8ee3692e195ea574e43c51a">projectionMatrixUniform</a>;<span class="comment">//a uniform location</span></div>
<div class="line"><span class="comment"></span>  GLint  <a name="a3"></a><a class="code" href="structQuadExampleVariables.html#a9c505e0a089ecd495b18550309ebab77">viewMatrixUniform</a>      ;<span class="comment">//a uniform location</span></div>
<div class="line"><span class="comment"></span>  GLuint <a name="a4"></a><a class="code" href="structQuadExampleVariables.html#a294c388653d62435d7eeb7994f45c4fc">vao</a>                    ;<span class="comment">//a vertex array id</span></div>
<div class="line"><span class="comment"></span>  GLuint <a name="a5"></a><a class="code" href="structQuadExampleVariables.html#a69515fd546272c117e14f784221f6412">vbo</a>                    ;<span class="comment">//vertex buffer object id</span></div>
<div class="line"><span class="comment"></span>  GLuint <a name="a6"></a><a class="code" href="structQuadExampleVariables.html#a3b1abdb0f18593a0ebec8dd9a222164b">ebo</a>                    ;<span class="comment">//vertex indices</span></div>
<div class="line">}<a name="a7"></a><a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>;</div>
</div><!-- fragment --><p>Projekční a view matice jsou uloženy v externích proměnných: </p><div class="fragment"><div class="line"><span class="keyword">extern</span> <a name="_a8"></a><a class="code" href="structMat4.html">Mat4</a> <a name="a9"></a><a class="code" href="mouseCamera_8c.html#a1f344d924f733a22d7659db612a0efe8">projectionMatrix</a>;<span class="comment">//projection matrix</span></div>
<div class="line"><span class="comment"></span><span class="keyword">extern</span> <a class="code" href="structMat4.html">Mat4</a> <a name="a10"></a><a class="code" href="mouseCamera_8c.html#ae64ebe4c77936fc93d161b97bd8e96df">viewMatrix</a>      ;<span class="comment">//view matrix</span></div>
</div><!-- fragment --><p>Pokud se hýbe s myší, jsou tyto matice přepočítávány.<br />
 Zdrojáky vertex a fragment shaderu jsou uloženy v proměnných: </p><div class="fragment"><div class="line"><span class="keywordtype">char</span> <span class="keyword">const</span>* <a name="a11"></a><a class="code" href="quadExample_8c.html#a237a7e498550119b6ce620c687d56f2e">quadExampleVertexShaderSource</a> = </div>
<div class="line"><span class="stringliteral">&quot;#version 330                                                   \n&quot;</span> <span class="comment">//a version of GLSL</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;uniform mat4 projectionMatrix;                                 \n&quot;</span> <span class="comment">//a uniform variable</span></div>
<div class="line"><span class="stringliteral">&quot;uniform mat4 viewMatrix;                                       \n&quot;</span> <span class="comment">//a uniform variable</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;layout(location=0)in vec3 position;                            \n&quot;</span> <span class="comment">//an input vertex attribute (it is read from buffer)</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;out vec3 vColor;                                               \n&quot;</span> <span class="comment">//an output vertex attribute (it is interpolated in rasterization)</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;void main(){                                                   \n&quot;</span> <span class="comment">//a main function</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;  gl_Position = projectionMatrix*viewMatrix*vec4(position,1.f);\n&quot;</span> <span class="comment">//a projection of a position from world-space into clip-space</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;  if(gl_VertexID == 0)vColor = vec3(1.f,0.f,0.f);              \n&quot;</span> <span class="comment">//a computation of color</span></div>
<div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 1)vColor = vec3(0.f,1.f,0.f);              \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 2)vColor = vec3(0.f,0.f,1.f);              \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 3)vColor = vec3(0.f,1.f,1.f);              \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;}                                                              \n&quot;</span>;</div>
</div><!-- fragment --><div class="fragment"><div class="line"><span class="keywordtype">char</span> <span class="keyword">const</span>* <a name="a12"></a><a class="code" href="quadExample_8c.html#a0ac50d89d2665b7f77595f36071c8ffc">quadExampleFragmentShaderSource</a> = </div>
<div class="line"><span class="stringliteral">&quot;#version 330                      \n&quot;</span> <span class="comment">//a version of GLSL</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;in vec3 vColor;                   \n&quot;</span> <span class="comment">//an input fragment attribute (it was interpolated using vertex attributes)</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;layout(location=0)out vec4 fColor;\n&quot;</span> <span class="comment">//an output fragment attribute (it is sent to framebuffer)</span></div>
<div class="line"><span class="comment"></span><span class="stringliteral">&quot;void main(){                      \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;  fColor = vec4(vColor,1.f);      \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;}                                 \n&quot;</span>;</div>
</div><!-- fragment --><h1><a class="anchor" id="Initialization"></a>
Inicializace</h1>
<p>Když je příklad spuštěn, je zavolána funkce <a class="el" href="quadExample_8c.html#ae9e7b1446d0269014f3f3d33df3f0da0" title="[FRAGMENTSHADER] ">quadExample_onInit()</a>. Tato funkce vytvoří opengl objekty (buffer, vertex arrays, shader programy). První funkční volání inicializuje matice: </p><div class="fragment"><div class="line">  <a name="a13"></a><a class="code" href="mouseCamera_8c.html#a7e7e918a9328502b7c35cfbbdb068b7b">cpu_initMatrices</a>(width,height);</div>
</div><!-- fragment --><h2><a class="anchor" id="ShaderProgram"></a>
Inicializace shader programu</h2>
<p>Dále následuje kopilace shaderů a linkování shader programu: </p><div class="fragment"><div class="line">  GLuint <span class="keyword">const</span> vertexId = <a name="a14"></a><a class="code" href="program_8h.html#aeeb65abe90cc1be97e5788afe8ca57a7">compileShader</a>(</div>
<div class="line">      GL_VERTEX_SHADER             , <span class="comment">//a type of shader</span></div>
<div class="line">      <a class="code" href="quadExample_8c.html#a237a7e498550119b6ce620c687d56f2e">quadExampleVertexShaderSource</a>);<span class="comment">//a glsl source</span></div>
<div class="line"></div>
<div class="line">  GLuint <span class="keyword">const</span> fragmentId = <a class="code" href="program_8h.html#aeeb65abe90cc1be97e5788afe8ca57a7">compileShader</a>(</div>
<div class="line">      GL_FRAGMENT_SHADER             , <span class="comment">//a type of shader</span></div>
<div class="line">      <a class="code" href="quadExample_8c.html#a0ac50d89d2665b7f77595f36071c8ffc">quadExampleFragmentShaderSource</a>);<span class="comment">//a glsl source</span></div>
<div class="line"></div>
<div class="line">  <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a> = <a name="a15"></a><a class="code" href="program_8h.html#af917a75fb9e573fb52d85ef90f32231e">linkProgram</a>(vertexId,fragmentId);</div>
</div><!-- fragment --><p>Shader program je program, který běží na GPU a je psán v jazyce GLSL.<br />
 Následuje získaní lokací (id) uniformních proměnných v shader programu pro matice: </p><div class="fragment"><div class="line">  <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a38a1023cb8ee3692e195ea574e43c51a">projectionMatrixUniform</a> = glGetUniformLocation(</div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a>, <span class="comment">//a program id</span></div>
<div class="line">      <span class="stringliteral">&quot;projectionMatrix&quot;</span> );<span class="comment">//a uniform variable name</span></div>
<div class="line"></div>
<div class="line">  <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a9c505e0a089ecd495b18550309ebab77">viewMatrixUniform</a> = glGetUniformLocation(</div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a>, <span class="comment">//a program id</span></div>
<div class="line">      <span class="stringliteral">&quot;viewMatrix&quot;</span>       );<span class="comment">//a uniform variable name</span></div>
</div><!-- fragment --><p>Lokace uniformní proměnné je celé číslo, které je dostupné na straně CPU a slouží jako handle pro náhrání dat do dané proměnné. Lokaci uniformní proměnné lze získat pomocí jejího jména. </p>
<h2><a class="anchor" id="Buffers"></a>
Inicializace bufferů (lineární pole na GPU)</h2>
<p>Následuje inicializace bufferu pro vrcholy. Vrcholy jsou uloženy ve statickém poli: </p><div class="fragment"><div class="line">  <span class="keywordtype">float</span> <span class="keyword">const</span> positions[12] = {<span class="comment">//vertex positions</span></div>
<div class="line">    -1.f,-1.f,+0.f,<span class="comment">//a quad vertex A</span></div>
<div class="line">    +1.f,-1.f,+0.f,<span class="comment">//a quad vertex B</span></div>
<div class="line">    -1.f,+1.f,+0.f,<span class="comment">//a quad vertex C</span></div>
<div class="line">    +1.f,+1.f,+0.f,<span class="comment">//a quad vertex D</span></div>
<div class="line">  };</div>
</div><!-- fragment --><p>Nejprve je nutné zarezervovat jmeno(id) bufferu: </p><div class="fragment"><div class="line">  glGenBuffers(</div>
<div class="line">      1               , <span class="comment">//a number of buffer ids that will be reserved</span></div>
<div class="line">      &amp;<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a69515fd546272c117e14f784221f6412">vbo</a>);<span class="comment">//a pointer to buffer id variable</span></div>
</div><!-- fragment --><p>Poté je nutné id bufferu navázat na vhodný binding point opengl: </p><div class="fragment"><div class="line">  glBindBuffer(</div>
<div class="line">      GL_ARRAY_BUFFER, <span class="comment">//a binding point</span></div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a69515fd546272c117e14f784221f6412">vbo</a>);<span class="comment">//a buffer id</span></div>
</div><!-- fragment --><p>GL_ARRAY_BUFFER binding point slouží pro vertex attributy. Následuje nahrání dat na GPU: </p><div class="fragment"><div class="line">  glBufferData(</div>
<div class="line">      GL_ARRAY_BUFFER , <span class="comment">//a binding point</span></div>
<div class="line">      <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>)*12, <span class="comment">//a size of buffer</span></div>
<div class="line">      positions       , <span class="comment">//a pointer to data</span></div>
<div class="line">      GL_STATIC_DRAW  );<span class="comment">//a hint</span></div>
</div><!-- fragment --><p>Následuje vytvoření bufferu pro indexy. Postup je obdobný jako pro vertex atributy, jen binding point je jiný: </p><div class="fragment"><div class="line">  uint32_t <span class="keyword">const</span> indices[6] = {</div>
<div class="line">    0,1,2,</div>
<div class="line">    2,1,3,</div>
<div class="line">  };</div>
<div class="line">  glGenBuffers(1,&amp;<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a3b1abdb0f18593a0ebec8dd9a222164b">ebo</a>);</div>
<div class="line">  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a3b1abdb0f18593a0ebec8dd9a222164b">ebo</a>);</div>
<div class="line">  glBufferData(GL_ELEMENT_ARRAY_BUFFER,<span class="keyword">sizeof</span>(uint32_t)*6,indices,GL_STATIC_DRAW);</div>
</div><!-- fragment --><p>Tím je inicializace bufferů hotová. </p>
<h2><a class="anchor" id="VAO"></a>
Inicializace vertex arrays object (nastavení vertex pulleru)</h2>
<p>Následuje vytvoření a nastavení objektu Vertex Arrays. Tento objekt obsahuje nastavení vertex puller - ten sestavuje vertexy, které přícházení do vertex shaderu. Vertex je složen z několik vertex attributů, (v tomto příkladě pouze z jednoho) Nejprve je nutné získát lokaci vstupní proměnné ve vertex shaderu, pro kterou sa nastavuje čtecí hlava: </p><div class="fragment"><div class="line">  GLint <span class="keyword">const</span> positionAttribute = glGetAttribLocation(</div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a>, <span class="comment">//a program id</span></div>
<div class="line">      <span class="stringliteral">&quot;position&quot;</span>         );<span class="comment">//a name of vertex attribute</span></div>
</div><!-- fragment --><p>První krok spočívá v rezervování jména (id) vertex arrays objektu (vao): </p><div class="fragment"><div class="line">  glGenVertexArrays(</div>
<div class="line">      1               , <span class="comment">//a number of vertex arrays</span></div>
<div class="line">      &amp;<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a294c388653d62435d7eeb7994f45c4fc">vao</a>);<span class="comment">//a pointer to first </span></div>
</div><!-- fragment --><p>Nastavení vao se provádí mezi příkazy pro aktivaci a dekativaci, další krok je proto aktivace: </p><div class="fragment"><div class="line">  glBindVertexArray(<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a294c388653d62435d7eeb7994f45c4fc">vao</a>);</div>
</div><!-- fragment --><p>Pro nastavení indexování je nutné navázat element buffer: </p><div class="fragment"><div class="line">  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a3b1abdb0f18593a0ebec8dd9a222164b">ebo</a>);</div>
</div><!-- fragment --><p>Pro nastavení vertex attributů je pořeba specifikovat, ze kterého bufferu bude daný atribut čten: </p><div class="fragment"><div class="line">  glBindBuffer(</div>
<div class="line">      GL_ARRAY_BUFFER,</div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a69515fd546272c117e14f784221f6412">vbo</a>);</div>
</div><!-- fragment --><p>Dále je nutné specifikovat, kde se vertex attribut v bufferu nachází (konfigurace čtecí hlavy): </p><div class="fragment"><div class="line">  glVertexAttribPointer(</div>
<div class="line">      (GLuint)positionAttribute, <span class="comment">//an attribute index</span></div>
<div class="line">      3                        , <span class="comment">//a number of components</span></div>
<div class="line">      GL_FLOAT                 , <span class="comment">//a type of attribute</span></div>
<div class="line">      GL_FALSE                 , <span class="comment">//a normalization</span></div>
<div class="line">      <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>)*3          , <span class="comment">//a stride in bytes</span></div>
<div class="line">      (GLvoid <span class="keyword">const</span>*)0         );<span class="comment">//an offset in bytes</span></div>
</div><!-- fragment --><p>Vertex attribut (pozice) je složen ze 3 komponent, typu float, je uložen těsně za sebou a začíná na začátku bufferu (nulový offset).<br />
 Poté je nutné vertex attribut povolit: </p><div class="fragment"><div class="line">  glEnableVertexAttribArray((GLuint)positionAttribute);</div>
</div><!-- fragment --><p>Nakonec je nutné deaktivovat vao: </p><div class="fragment"><div class="line">  glBindVertexArray(0);</div>
</div><!-- fragment --><p>Tím je inicializace hotová. </p>
<h1><a class="anchor" id="Deinit"></a>
Deinicializace</h1>
<p>Deinicializace/uvolnění zdrojů probíhá ve funkci <a class="el" href="quadExample_8c.html#a19bc4ebaa15f60078724033bde27d8b9" title="This function is called at end of application. ">quadExample_onExit()</a>. V této funkci je nutné uvolnit program, buffery a vertex arrays object: </p><div class="fragment"><div class="line">  glDeleteProgram(<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a>);</div>
<div class="line">  glDeleteBuffers(1,&amp;<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a69515fd546272c117e14f784221f6412">vbo</a>);</div>
<div class="line">  glDeleteBuffers(1,&amp;<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a3b1abdb0f18593a0ebec8dd9a222164b">ebo</a>);</div>
<div class="line">  glDeleteVertexArrays(1,&amp;<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a294c388653d62435d7eeb7994f45c4fc">vao</a>);</div>
</div><!-- fragment --><h1><a class="anchor" id="Shaders"></a>
Shadery</h1>
<p>Shadery jsou uloženy ve statických řetězcích. Shadery jsou psány v jazyce GLSL.<br />
 Každý shader musí mít na prvním řádku uvedenou verzi. </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;#version 330                                                   \n&quot;</span> <span class="comment">//a version of GLSL</span></div>
</div><!-- fragment --><h2><a class="anchor" id="VertexShader"></a>
Vertex Shader</h2>
<p>Vertex shader v tomto příkladě promítá vrcholy pomocí matic do clip-space a počítá barvu vrcholu z jeho pořadového čísla. Vertex shader začíná deklarací interface.<br />
 Interface je složen z uniformních proměnných: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;uniform mat4 projectionMatrix;                                 \n&quot;</span> <span class="comment">//a uniform variable</span></div>
<div class="line"><span class="stringliteral">&quot;uniform mat4 viewMatrix;                                       \n&quot;</span> <span class="comment">//a uniform variable</span></div>
</div><!-- fragment --><p>Interface dále obsahuje vertex atribut pro pozici vrcholu: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;layout(location=0)in vec3 position;                            \n&quot;</span> <span class="comment">//an input vertex attribute (it is read from buffer)</span></div>
</div><!-- fragment --><p>Poslední položka interface je výstupní vertex atribut pro barvu vrcholu: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;out vec3 vColor;                                               \n&quot;</span> <span class="comment">//an output vertex attribute (it is interpolated in rasterization)</span></div>
</div><!-- fragment --><p>Pokud před deklarací proměnné leží klíčoví slovo in, out nebo uniform je proměnná součástí interface. Z proměnných "in" a "uniform" lze pouze číst. Do proměnných "out" lze pouze zapisovat. Proměnné "in" a "out" mohou obsahovat pro každý vrchol jinou hodnotu. Proměnné "uniform" slouží pro uložení konstant, které zůstávají stejné po dobu jednoho vykreslujícího příkazu. "layout(location=n)" explicitně specifikuje lokaci dané proměnné."<br />
 Tělo shaderu tvoří funkce main: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;void main(){                                                   \n&quot;</span> <span class="comment">//a main function</span></div>
</div><!-- fragment --><p>Ve funkci main se nejprve spočítá pozice v clip-space: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;  gl_Position = projectionMatrix*viewMatrix*vec4(position,1.f);\n&quot;</span> <span class="comment">//a projection of a position from world-space into clip-space</span></div>
</div><!-- fragment --><p>Jazyk GLSL umožňuje násobení vektorů a matic a rozšíření trojsložkového vektoru na čtyřsložkový.<br />
 Následně se spočíta brava z čísla vrcholu: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 0)vColor = vec3(1.f,0.f,0.f);              \n&quot;</span> <span class="comment">//a computation of color</span></div>
<div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 1)vColor = vec3(0.f,1.f,0.f);              \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 2)vColor = vec3(0.f,0.f,1.f);              \n&quot;</span></div>
<div class="line"><span class="stringliteral">&quot;  if(gl_VertexID == 3)vColor = vec3(0.f,1.f,1.f);              \n&quot;</span></div>
</div><!-- fragment --><h2><a class="anchor" id="FragmentShader"></a>
Fragment Shader</h2>
<p>Stejně jako vertex shader, fragment shader také začíná deklarací interface.<br />
 Interface je složen ze vstupního fragment atributu barvy: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;in vec3 vColor;                   \n&quot;</span> <span class="comment">//an input fragment attribute (it was interpolated using vertex attributes)</span></div>
</div><!-- fragment --><p>Název proměnné musí odpovídat názvu příslušné proměnné ve vertex shaderu, liší se pouze v kvalifikátoru "in/out". Proměnná bude obsahovat interpolovanou barvu.<br />
 Následuje specifikace výstupního fragment atributu: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;layout(location=0)out vec4 fColor;\n&quot;</span> <span class="comment">//an output fragment attribute (it is sent to framebuffer)</span></div>
</div><!-- fragment --><p>Výstupní atribut na pozici 0 je automaticky zapsán přes per-fragment operace do framebufferu.<br />
 Ve funkci main je barva pouze přeposlána ze vstupní proměnné do výstupní proměnné: </p><div class="fragment"><div class="line"><span class="stringliteral">&quot;  fColor = vec4(vColor,1.f);      \n&quot;</span></div>
</div><!-- fragment --><h1><a class="anchor" id="Draw"></a>
Kreslení</h1>
<p>Kreslení je zajištěno funkci <a class="el" href="quadExample_8c.html#a357ede357c44b3a5a41681591a1108c8" title="This function is called every frame and is responsible for drawing. ">quadExample_onDraw()</a>. Funkce nejprve vyčistí framebuffer: </p><div class="fragment"><div class="line">  glClear(</div>
<div class="line">      GL_COLOR_BUFFER_BIT| <span class="comment">//clear color buffer</span></div>
<div class="line">      GL_DEPTH_BUFFER_BIT);<span class="comment">//clear depth buffer</span></div>
</div><!-- fragment --><p>Následně aktivuje shader program: </p><div class="fragment"><div class="line">  glUseProgram(<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a63971781ff860bd201886926f943ba78">program</a>);</div>
</div><!-- fragment --><p>Aktivuje vertex arrays object (vao): </p><div class="fragment"><div class="line">  glBindVertexArray(<a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a294c388653d62435d7eeb7994f45c4fc">vao</a>);</div>
</div><!-- fragment --><p>Nahraje aktuální matice na GPU: </p><div class="fragment"><div class="line">  glUniformMatrix4fv(</div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a38a1023cb8ee3692e195ea574e43c51a">projectionMatrixUniform</a>, <span class="comment">//location of uniform variable</span></div>
<div class="line">      1                                  , <span class="comment">//number of matrices</span></div>
<div class="line">      GL_FALSE                           , <span class="comment">//transpose</span></div>
<div class="line">      (<span class="keywordtype">float</span>*)&amp;projectionMatrix          );<span class="comment">//pointer to data</span></div>
<div class="line">  glUniformMatrix4fv(</div>
<div class="line">      <a class="code" href="quadExample_8c.html#ad961415145a9c30bd9846d4a278cc63a">quadExample</a>.<a class="code" href="structQuadExampleVariables.html#a9c505e0a089ecd495b18550309ebab77">viewMatrixUniform</a>, <span class="comment">//location of uniform variable</span></div>
<div class="line">      1                            , <span class="comment">//number of matrices</span></div>
<div class="line">      GL_FALSE                     , <span class="comment">//transpose</span></div>
<div class="line">      (<span class="keywordtype">float</span>*)&amp;viewMatrix          );<span class="comment">//pointer to data</span></div>
</div><!-- fragment --><p>Spustí kreslení: </p><div class="fragment"><div class="line">  glDrawElements(</div>
<div class="line">      GL_TRIANGLES    , <span class="comment">//primitive type</span></div>
<div class="line">      6               , <span class="comment">//number of indices</span></div>
<div class="line">      GL_UNSIGNED_INT , <span class="comment">//type of indices</span></div>
<div class="line">      (GLvoid <span class="keyword">const</span>*)0);<span class="comment">//offset</span></div>
</div><!-- fragment --><p>A nakonec deaktivuje vao: </p><div class="fragment"><div class="line">  glBindVertexArray(0);</div>
</div><!-- fragment --> <div class="fragment"></div><!-- fragment --> </div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Apr 24 2019 08:37:08 for Izg 2018 - 2019, lab 6. by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
